/*
 *
 *  Copyright (C) 2007  Uwe Weng
 *
 *  This file is part of Fuzzy Services, a library for processing fuzzy
 *  information.
 *
 *  Fuzzy Services are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Fuzzy Services are distributed in the hope that they will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Fuzzy Services; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  The license is also available at http://www.gnu.org/licenses/gpl.txt
 *
 ******************************************************************************/
package net.sourceforge.fuzzyservices.beans;

import net.sourceforge.fuzzyservices.swing.LinguisticVariableModel;

/**
 * Panel for editing linguistic term array property.
 *
 * @version 1.0
 * @author Uwe Weng
 */
public class LinguisticTermArrayEditorPanel extends javax.swing.JPanel {

    /** Creates new form LinguisticTermArrayEditorPanel */
    public LinguisticTermArrayEditorPanel() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        linguisticVariableTabbedPane = new net.sourceforge.fuzzyservices.swing.LinguisticVariableTabbedPane();
        linguisticVariablePanel = new net.sourceforge.fuzzyservices.swing.LinguisticVariablePanel();

        setLayout(new java.awt.BorderLayout());

        linguisticVariableTabbedPane.setName("linguisticVariableTabbedPane"); // NOI18N
        add(linguisticVariableTabbedPane, java.awt.BorderLayout.PAGE_END);

        linguisticVariablePanel.setName("linguisticVariablePanel"); // NOI18N

        javax.swing.GroupLayout linguisticVariablePanelLayout = new javax.swing.GroupLayout(linguisticVariablePanel);
        linguisticVariablePanel.setLayout(linguisticVariablePanelLayout);
        linguisticVariablePanelLayout.setHorizontalGroup(
            linguisticVariablePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        linguisticVariablePanelLayout.setVerticalGroup(
            linguisticVariablePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 262, Short.MAX_VALUE)
        );

        add(linguisticVariablePanel, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    net.sourceforge.fuzzyservices.swing.LinguisticVariablePanel linguisticVariablePanel;
    net.sourceforge.fuzzyservices.swing.LinguisticVariableTabbedPane linguisticVariableTabbedPane;
    // End of variables declaration//GEN-END:variables
    protected LinguisticVariableModel linguisticVariableModel;
    public static final String LINGUISTIC_VARIABLE_MODEL = "linguisticVariableModel";

    /**
     * Get the value of linguisticVariableModel
     *
     * @return the value of linguisticVariableModel
     */
    public LinguisticVariableModel getLinguisticVariableModel() {
        return linguisticVariableModel;
    }

    /**
     * Set the value of linguisticVariableModel
     *
     * @param linguisticVariableModel new value of linguisticVariableModel
     */
    public void setLinguisticVariableModel(LinguisticVariableModel linguisticVariableModel) {
        LinguisticVariableModel oldLinguisticVariableModel = linguisticVariableModel;
        this.linguisticVariableModel = linguisticVariableModel;
        firePropertyChange(LINGUISTIC_VARIABLE_MODEL, oldLinguisticVariableModel, linguisticVariableModel);
        linguisticVariablePanel.setModel(linguisticVariableModel);
        // TODO
        // linguisticVariableTabbedPane.setModel...
    }

    /**
     * Constructs a panel that is initialized with <code>linguisticVariableModel</code> as the model.
     * @param linguisticVariableModel the model for the panel
     */
    public LinguisticTermArrayEditorPanel(LinguisticVariableModel linguisticVariableModel) {
        this();
        setLinguisticVariableModel(linguisticVariableModel);
    }

}
