/*
 *
 *  Copyright (C) 2007  Uwe Weng
 *
 *  This file is part of Fuzzy Services, a library for processing fuzzy
 *  information.
 *
 *  Fuzzy Services are free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Fuzzy Services are distributed in the hope that they will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Fuzzy Services; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  The license is also available at http://www.gnu.org/licenses/gpl.txt
 *
 ******************************************************************************/
package net.sourceforge.fuzzyservices.beans;

import net.sourceforge.fuzzyservices.swing.RuleBaseModel;

/**
 * Panel for editing rule array property.
 *
 * @version 1.0
 * @author Uwe Weng
 */
public class RuleArrayEditorPanel extends javax.swing.JPanel {

    /** Creates new form RuleArrayEditorPanel */
    public RuleArrayEditorPanel() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        ruleListEditorPanel = new net.sourceforge.fuzzyservices.swing.RuleListEditorPanel();

        setLayout(new java.awt.BorderLayout());

        ruleListEditorPanel.setName("ruleListEditorPanel"); // NOI18N
        add(ruleListEditorPanel, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    net.sourceforge.fuzzyservices.swing.RuleListEditorPanel ruleListEditorPanel;
    // End of variables declaration//GEN-END:variables
    protected RuleBaseModel ruleBaseModel;
    public static final String RULE_BASE_MODEL = "ruleBaseModel";

    /**
     * Get the value of ruleBaseModel
     *
     * @return the value of ruleBaseModel
     */
    public RuleBaseModel getRuleBaseModel() {
        return ruleBaseModel;
    }

    /**
     * Set the value of ruleBaseModel
     *
     * @param ruleBaseModel new value of ruleBaseModel
     */
    public void setRuleBaseModel(RuleBaseModel ruleBaseModel) {
        RuleBaseModel oldRuleBaseModel = ruleBaseModel;
        this.ruleBaseModel = ruleBaseModel;
        firePropertyChange(RULE_BASE_MODEL, oldRuleBaseModel, ruleBaseModel);
        ruleListEditorPanel.setModel(ruleBaseModel);
    }

    /**
     * Constructs a panel that is initialized with <code>ruleBaseModel</code> as the model.
     * @param ruleBaseModel the model for the panel
     */
    public RuleArrayEditorPanel(RuleBaseModel ruleBaseModel) {
        this();
        setRuleBaseModel(ruleBaseModel);
    }

}
